﻿using System;
using Android.Views;
using CustomEvents;
using CustomEvents.Droid;
using Xamarin.Forms;
using Xamarin.Forms.Platform.Android;


[assembly: ExportRenderer(typeof(CustomView), typeof(CustomChangeViewRenderer))]
namespace CustomEvents.Droid
{
	public class CustomChangeViewRenderer : ViewRenderer<CustomView, Android.Widget.LinearLayout>
	{

		protected override void OnElementChanged(ElementChangedEventArgs<CustomView> e)
		{
			base.OnElementChanged(e);
			TapGestureLister gesture = new TapGestureLister(e);
			GestureDetector gestureDetector = new GestureDetector(this.Context, gesture);
			this.Touch += (sender, ee) =>
			{
				gestureDetector.OnTouchEvent(ee.Event);
			};
		}
	}

	internal class TapGestureLister : GestureDetector.SimpleOnGestureListener
	{

		ElementChangedEventArgs<CustomView> ele;

		public TapGestureLister(ElementChangedEventArgs<CustomView> e)
		{
			ele = e;
		}

		public override void OnLongPress(MotionEvent e)
		{
			ele.NewElement.OnLongPressed();
			base.OnLongPress(e);


		}

		public override bool OnDoubleTap(MotionEvent e)
		{
			ele.NewElement.OnDoubleTapped();
			return base.OnDoubleTap(e);


		}

		public override bool OnSingleTapConfirmed(MotionEvent e)
		{
			ele.NewElement.OnTapped();
			return base.OnSingleTapConfirmed(e);


		}

	}



}
