﻿using System;
using Xamarin.Forms;
using FlexGridCustomRenderer.iOS;
using Xamarin.Forms.Platform.iOS;
using UIKit;
using CustomEvents;
using System.Diagnostics;
[assembly: ExportRenderer(typeof(CustomView), typeof(CustomChangeViewRenderer))]
namespace FlexGridCustomRenderer.iOS
{
	public class CustomChangeViewRenderer : ViewRenderer<CustomView, UIView>
	{


		protected override void OnElementChanged(ElementChangedEventArgs<CustomView> e)
		{
			base.OnElementChanged(e);

			UITapGestureRecognizer singleTap = new UITapGestureRecognizer(st =>
			{
				e.NewElement.OnTapped();
			}
			);
			singleTap.NumberOfTapsRequired = 1;
			this.AddGestureRecognizer(singleTap);


			UITapGestureRecognizer doubleTap = new UITapGestureRecognizer(st =>
			{
				e.NewElement.OnDoubleTapped();
			}
			);
			doubleTap.NumberOfTapsRequired = 2;
			this.AddGestureRecognizer(doubleTap);
			singleTap.RequireGestureRecognizerToFail(doubleTap);

			this.AddGestureRecognizer(new UILongPressGestureRecognizer(lp =>

		   {
			   if (lp.State == UIGestureRecognizerState.Began)
			   {
				   e.NewElement.OnLongPressed();
			   }
		   }));


		}



	}
}